/*  fgwirc - fungw based minimal irc client
    Copyright (C) 2019  Tibor 'Igor2' Palinkas

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License along
    with this program; if not, write to the Free Software Foundation, Inc.,
    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

    Project page and contact: http://repo.hu/projects/fgwirc
*/

#ifndef CONF_H
#define CONF_H

#include <libfungw/fungw.h>
#include "global_typedefs.h"

struct conf_item_s {
	char *name;
	fgw_type_t type;
	void *var;

	void (*on_chg)(conf_item_t *item);
	char *desc;

	unsigned orig:1; /* still has the original value, hardwired from c (do not free()) */
};

void conf_reg(const char *name, fgw_type_t type, void *var, void (*on_chg)(conf_item_t *item), const char *desc);
int conf_set(char *name, char *val);
conf_item_t *conf_get(char *name);

void conf_init(void);
void conf_uninit(void);

#endif
